| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::GLSLESLinkProgram Class Reference

C++ encapsulation of GLSL ES Program Object. More...

`#include <OgreGLSLESLinkProgram.h>`

Inheritance diagram for Ogre::GLSLESLinkProgram:
[legend]

## Public Member Functions
| GLSLESLinkProgram (GLSLESProgram *vertexProgram, GLSLESProgram *fragmentProgram)
| Constructor should only be used by GLSLESLinkProgramManager. More...
virtual | ~GLSLESLinkProgram (void)
void | activate (void)
| Makes a program object active by making sure it is linked and then putting it in use. More...
void | bindFixedAttributes (GLuint program)
GLSLESProgram * | getFragmentProgram (void) const
uint | getGLProgramHandle (void) const
| Get the GL Handle for the program object. More...
GLSLESProgram * | getVertexProgram (void) const
bool | isSkeletalAnimationIncluded (void) const
| Returns whether the linked program includes the required instructions to perform skeletal animation. More...
bool | isUsingShader (GLSLShaderCommon *shader) const
| query if the program is using the given shader More...
void | setSkeletalAnimationIncluded (bool included)
| Sets whether the linked program includes the required instructions to perform skeletal animation. More...
virtual void | updatePassIterationUniforms (GpuProgramParametersSharedPtr params)
| Updates program object uniforms using data from pass iteration GpuProgramParameters. More...
virtual void | updateUniformBlocks (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)
| Updates program object uniform blocks using data from GpuProgramParameters. More...
virtual void | updateUniforms (GpuProgramParametersSharedPtr params, uint16 mask, GpuProgramType fromProgType)
| Updates program object uniforms using data from GpuProgramParameters. More...

## Static Public Member Functions
static int32 | getFixedAttributeIndex (VertexElementSemantic semantic, uint index)
| Get the fixed attribute bindings normally used by GL for a semantic. More...
static void | useTightAttributeLayout ()
| use alternate vertex attribute layout using only 8 vertex attributes More...

## Detailed Description

C++ encapsulation of GLSL ES Program Object.

## Constructor & Destructor Documentation

## ◆ GLSLESLinkProgram()

Ogre::GLSLESLinkProgram::GLSLESLinkProgram | ( | GLSLESProgram * | vertexProgram,
|  | GLSLESProgram * | fragmentProgram
| ) |  |

Constructor should only be used by GLSLESLinkProgramManager.

## ◆ ~GLSLESLinkProgram()

virtual Ogre::GLSLESLinkProgram::~GLSLESLinkProgram | ( | void |  | ) |
| virtual

## Member Function Documentation

## ◆ activate()

void Ogre::GLSLESLinkProgram::activate | ( | void |  | ) |
| virtual

Makes a program object active by making sure it is linked and then putting it in use.

Implements Ogre::GLSLProgramCommon.

## ◆ updateUniforms()

virtual void Ogre::GLSLESLinkProgram::updateUniforms | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| virtual

Updates program object uniforms using data from GpuProgramParameters.

normally called by GLSLESGpuProgram::bindParameters() just before rendering occurs.

Implements Ogre::GLSLProgramCommon.

## ◆ updateUniformBlocks()

virtual void Ogre::GLSLESLinkProgram::updateUniformBlocks | ( | GpuProgramParametersSharedPtr | params,
|  | uint16 | mask,
|  | GpuProgramType | fromProgType
| ) |  |
| virtual

Updates program object uniform blocks using data from GpuProgramParameters.

normally called by GLSLGpuProgram::bindParameters() just before rendering occurs.

Implements Ogre::GLSLProgramCommon.

## ◆ updatePassIterationUniforms()

virtual void Ogre::GLSLESLinkProgram::updatePassIterationUniforms | ( | GpuProgramParametersSharedPtr | params | ) |
| virtual

Updates program object uniforms using data from pass iteration GpuProgramParameters.

normally called by GLSLESGpuProgram::bindMultiPassParameters() just before multi pass rendering occurs.

Implements Ogre::GLSLProgramCommon.

## ◆ bindFixedAttributes()

void Ogre::GLSLESProgramCommon::bindFixedAttributes | ( | GLuint | program | ) |
| inherited

## ◆ getVertexProgram()

GLSLESProgram* Ogre::GLSLESProgramCommon::getVertexProgram | ( | void |  | ) | const
| inline inherited

## ◆ getFragmentProgram()

GLSLESProgram* Ogre::GLSLESProgramCommon::getFragmentProgram | ( | void |  | ) | const
| inline inherited

## ◆ isUsingShader()

bool Ogre::GLSLESProgramCommon::isUsingShader | ( | GLSLShaderCommon * | shader | ) | const
| inline virtual inherited

query if the program is using the given shader

Implements Ogre::GLSLProgramCommon.

## ◆ setSkeletalAnimationIncluded()

void Ogre::GLSLProgramCommon::setSkeletalAnimationIncluded | ( | bool | included | ) |
| inline inherited

Sets whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this is set to true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ isSkeletalAnimationIncluded()

bool Ogre::GLSLProgramCommon::isSkeletalAnimationIncluded | ( | void |  | ) | const
| inline inherited

Returns whether the linked program includes the required instructions to perform skeletal animation.

Remarks
  If this returns true, OGRE will not blend the geometry according to skeletal animation, it will expect the vertex program to do it.

## ◆ getGLProgramHandle()

uint Ogre::GLSLProgramCommon::getGLProgramHandle | ( | void |  | ) | const
| inline inherited

Get the GL Handle for the program object.

## ◆ getFixedAttributeIndex()

static int32 Ogre::GLSLProgramCommon::getFixedAttributeIndex | ( | VertexElementSemantic | semantic,
|  | uint | index
| ) |  |
| static inherited

Get the fixed attribute bindings normally used by GL for a semantic.

## ◆ useTightAttributeLayout()

static void Ogre::GLSLProgramCommon::useTightAttributeLayout | ( |  | ) |
| static inherited

use alternate vertex attribute layout using only 8 vertex attributes

For "Vivante GC1000" and "VideoCore IV" (notably in Raspberry Pi) on GLES2

The documentation for this class was generated from the following file:

- OgreGLSLESLinkProgram.h